/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import spirals.motol.database.Data;

/**
 * <p>Prohle vykresl graf zvislosti hlu vektoru rychlosti na dlce.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class LengthTabletDataViewer
    extends TimeTabletDataViewer {
  public LengthTabletDataViewer(JPanel screen, JPanel controls,
                                     Data data, boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
  }

  protected void setBottom(double[] x, double[] vect, double min, double max) {
    bottomViewer = new DoubleViewerBottom2(bottom, x, vect);
    bottomViewer.setMax(max);
    bottomViewer.setMin(min);
    bottom.removeMouseMotionListener(this);
    bottom.removeMouseListener(this);
  }

  public void updateData() {
    super.updateData();

    if(dcb != null) {
      int size = angle.length;
      double[] x = new double[size];
      for (int i = 1; i < size; i++) {
        double dx = tabletData.get(i).getX() - tabletData.get(i - 1).getX();
        double dy = tabletData.get(i).getY() - tabletData.get(i - 1).getY();
        x[i] = x[i - 1] + Math.sqrt(dx * dx + dy * dy);
      }
      this.setBottom(x, angle, minFi, maxFi);
    }
  }

  public String getDescription() {
    return
        "Graf v zvislosti na dlce.";
  }
}
