/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import spirals.motol.database.Data;

/**
 * <p>Prohle kter pouv cel data. st dvojokenho prohlee. Zobrazuje se pi vyznaen platnho seku dat po jejich sejmut z tabletu.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class TADoubleViewerTop
    extends DoubleViewerTop {
  private boolean changed = false;

  public TADoubleViewerTop(JPanel screen, JPanel controls, Data data,
                           boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
  }

  public JPanel getControls() {
    return controls;
  }

  public void setBegin(int start) {
    super.setBegin(start);
    this.changed = true;
  }

  public void setEnd(int end) {
    super.setEnd(end);
    this.changed = true;
  }

  /**
   * @return boolean vrac true, pokud byl vyznaen nov sek
   */
  public boolean changed() {
    return changed;
  }

  protected void setChanged(boolean changed) {
    this.changed = changed;
  }
}
