/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.motol.loaders;

import spirals.motol.database.*;

/**
 * <p>Tda, kter se star o nahrn databze z njakho loit.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
abstract public class DatabaseLoader {
  protected DatabaseLoader() {}

  public abstract PacientLoader getDefaultPacientLoader();

  public abstract void load(Database database);

  public abstract void save(Database database);

  public abstract long getDatabaseSize(Database database);

  public abstract void exportData(Database database);

  public abstract void importData(Database database);

  /**
   * Metoda pipoj datbazi temp k databzi database. Algoritmus spojuje pacienty podle jejich uniktnho ID.
   * @param database Database databze do kter se data nahraj
   * @param temp Database databze ze kter se data tou
   */
  public static void merge(Database database, Database temp) {
    for (Pacient np : temp.getAll()) {
      PacientLoader.merge(database.getLoader().getDefaultPacientLoader().
                          getDefaultVisitLoader(),
                          database.getPacient(np.getLongID()), np);

      np.setDatabase(database);
//      np.setLoader(database.getLoader().getDefaultPacientLoader());
      np.save();
    }
    database.save();
  }

}
