/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.motol.loaders;

import spirals.motol.database.*;
import java.util.List;

/**
 * <p>Tda, kter se star o nahrn pacienta z njakho loit.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
abstract public class PacientLoader {
  protected static PacientLoader instance = null;

  protected PacientLoader() {}

  public static PacientLoader getInstance() {return instance;}

  public abstract VisitLoader getDefaultVisitLoader();
  /**
   * Nahraje pacienta s uniktnm ID z loit
   * @param pacient Pacient do tto tdy pacienta ulo
   * @param ID String
   */
  public abstract void load(Pacient pacient, String ID);
  public abstract void save(Pacient pacient);
  /**
   * vymn u danho pacienta star ID za nov
   * @param p Pacient
   * @param oldID String
   * @param newID String
   * @return boolean
   */
  public abstract boolean replace(Pacient p, String oldID, String newID);
  /**
   * nahraje z loit nvtvy pacienta
   * @param pacient Pacient
   * @return List
   */
  public abstract List<Visit> getVisits(Pacient pacient);

  /**
   * slou nvtvy pacienta s s nvtvymi pacienta temp
   * @param loader VisitLoader implicitn nahrva nvtv z loit
   * @param pacient Pacient ke komu nvtvy pidat
   * @param temp Pacient koho nvtvy pidat
   */
  public static void merge(VisitLoader loader, Pacient pacient, Pacient temp) {
    for (Visit nv : temp.getVisits()) {
      if(pacient == null) {
        VisitLoader.merge(loader.getDefaultDataLoader(), null, nv);
        nv.setLoader(loader);
      } else {
        VisitLoader.merge(loader.getDefaultDataLoader(), pacient.visitExists(nv), nv);
        nv.setPacient(pacient);
      }

      nv.save();
    }
  }
}
