/*      Author: Miroslav Skrbek, Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package tablet;

import java.util.EventListener;

/**
 * <p>Interface that must implement class which wants to receive tablet packets</p>
 *
 * <p>Copyright: Copyright (c) 2005 Miroslav Skrbek, Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Miroslav Skrbek, Jan Dolezel
 * @version 1.2
 */
public interface TabletListener extends EventListener {
    /**
     * method is called after tablet produces new packet
     * @param packet new tablet point
     */
    public void onTabletPacket(TabletPoint packet);
    public void onTimeout();
}
