import java.io.*;
import java.util.zip.*;
import java.util.*;

public class MainClass {
  public MainClass() {
  }

  public static void main(String[] args) {
    File root = new File(".");
    FilenameFilter filter = new FilenameFilter() {
      public boolean accept(File f, String name) {
        return name.endsWith("zip");
      }
    };
    for(File file: root.listFiles(filter)) {
      ZipInputStream in = null;
      List<TabletPoint> vektor = new ArrayList<TabletPoint>();
      try {
        in = new ZipInputStream(new FileInputStream(file));
        in.getNextEntry(); // first and only entry in zip file
        byte buff[] = new byte[20];
        int len = 0;
        while((len = in.read(buff)) > -1) {
          while (len != 20) { // read until all twenty bytes of one point are collected
            byte array[] = new byte[20-len];
            len += in.read(array);
            System.arraycopy(array, 0, buff, 20-array.length, array.length);
          }
          vektor.add(new TabletPoint(buff));
        }
        in.closeEntry();
      } catch(IOException e) {
        System.err.println("Chyba nacitani dat");
        e.printStackTrace();
      } finally {
        if (in != null) {
          try {
            in.close();
          }
          catch (IOException e) {}
        }
      }
      File out = new File(file.getName().replaceAll(".zip", ".dat"));
      PrintStream os = null;
      try {
        out.createNewFile();
        os = new PrintStream(out);
        TabletPoint.printHeader(os);
        for(TabletPoint tp: vektor) {
          tp.print(os);
        }
        System.out.println(file + " preveden");
      } catch(IOException e) {
        System.err.println("Chyba zapisu dat");
        e.printStackTrace();
      } finally {
        if (os != null) {
          os.close();
        }
      }
    }
  }
}
